#!/bin/bash

# Automates the packaging process of the software "xorg-apps" for
# use with Zenwalk Linux.
#	
# Copyright (C) 2009 Michael Verret <michael.verret@gmail.com>

# Summary:	X11 applications
# Name:		xorg-apps
# Group:	Development/System
# URL:		http://sourceforge.jp/projects/anthy/
# URL:		http://www.scim-im.org/
# URL:		http://www.x.org

# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/appres-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/bdftopcf-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/beforelight-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/bitmap-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/editres-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/fonttosfnt-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/fslsfonts-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/fstobdf-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/iceauth-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/ico-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/lbxproxy-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/listres-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/luit-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/mkcomposecache-1.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/mkfontdir-1.0.4-noarch-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/mkfontscale-1.0.4-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/oclock-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/proxymngr-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/rendercheck-1.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/rgb-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/rstart-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/sessreg-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/showfont-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/smproxy-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/twm-1.0.4-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/viewres-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/x11perf-1.5-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xauth-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xbacklight-1.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xbiff-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xcalc-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xclipboard-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xclock-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xcmsdb-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xcompmgr-1.1.4-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xconsole-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xcursorgen-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xdbedizzy-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xditview-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xdm-1.1.7-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xdpyinfo-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xdriinfo-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xedit-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xev-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xeyes-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xf86dga-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xfd-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xfindproxy-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xfontsel-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xfs-1.0.6-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xfsinfo-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xfwp-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xgamma-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xgc-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xhost-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xinit-1.0.8-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xinput-1.3.0-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xkbcomp-1.0.4-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xkbutils-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xkill-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xload-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xlogo-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xlsatoms-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xlsclients-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xlsfonts-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xmag-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xman-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xmessage-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xmh-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xmodmap-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xmore-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xphelloworld-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xplsprinters-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xpr-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xprehashprinterlist-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xprop-1.0.4-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xrandr-1.2.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xrdb-1.0.5-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xrefresh-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xrx-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xset-1.0.4-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xsetmode-1.0.0-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xsetpointer-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xsetroot-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xsm-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xstdcmap-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xvidtune-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xvinfo-1.0.2-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xwd-1.0.1-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xwininfo-1.0.3-i486-1.tgz
# Source:	http://slackware.cs.utah.edu/pub/slackware/slackware-current/slackware/x/xwud-1.0.1-i486-1.tgz



# Variables:
#_______________________________________________________________________



Source_Name=" "
Software_Name="xorg-apps"
Source_Version="7.3.2"
Software_Version="${Source_Version}"
Release="60"
Build="2"

Flag_Arch='i486'
Flag_Tune='i686'
Package_Arch="${Flag_Arch}"

Build_Root=$(pwd)
Package="${Software_Name}-${Software_Version}-${Package_Arch}-${Release}.${Build}"
Installation_Root="${Build_Root}/${Package}"

Sources=" "
SlackPkgs=" \
	appres-1.0.1-i486-1.tgz \
	bdftopcf-1.0.1-i486-1.tgz \
	beforelight-1.0.2-i486-1.tgz \
	bitmap-1.0.3-i486-1.tgz \
	editres-1.0.3-i486-1.tgz \
	fonttosfnt-1.0.3-i486-1.tgz \
	fslsfonts-1.0.1-i486-1.tgz \
	fstobdf-1.0.2-i486-1.tgz \
	iceauth-1.0.2-i486-1.tgz \
	ico-1.0.2-i486-1.tgz \
	lbxproxy-1.0.1-i486-1.tgz \
	listres-1.0.1-i486-1.tgz \
	luit-1.0.3-i486-1.tgz \
	mkcomposecache-1.2-i486-1.tgz \
	mkfontdir-1.0.4-noarch-1.tgz \
	mkfontscale-1.0.4-i486-1.tgz \
	oclock-1.0.1-i486-1.tgz \
	proxymngr-1.0.1-i486-1.tgz \
	rendercheck-1.3-i486-1.tgz \
	rgb-1.0.1-i486-1.tgz \
	rstart-1.0.2-i486-1.tgz \
	sessreg-1.0.3-i486-1.tgz \
	showfont-1.0.1-i486-1.tgz \
	smproxy-1.0.2-i486-1.tgz \
	twm-1.0.4-i486-1.tgz \
	viewres-1.0.1-i486-1.tgz \
	x11perf-1.5-i486-1.tgz \
	xauth-1.0.3-i486-1.tgz \
	xbacklight-1.1-i486-1.tgz \
	xbiff-1.0.1-i486-1.tgz \
	xcalc-1.0.2-i486-1.tgz \
	xclipboard-1.0.1-i486-1.tgz \
	xclock-1.0.3-i486-1.tgz \
	xcmsdb-1.0.1-i486-1.tgz \
	xcompmgr-1.1.4-i486-1.tgz \
	xconsole-1.0.3-i486-1.tgz \
	xcursorgen-1.0.2-i486-1.tgz \
	xdbedizzy-1.0.2-i486-1.tgz \
	xditview-1.0.1-i486-1.tgz \
	xdm-1.1.7-i486-1.tgz \
	xdpyinfo-1.0.2-i486-1.tgz \
	xdriinfo-1.0.2-i486-1.tgz \
	xedit-1.0.2-i486-1.tgz \
	xev-1.0.3-i486-1.tgz \
	xeyes-1.0.1-i486-1.tgz \
	xf86dga-1.0.2-i486-1.tgz \
	xfd-1.0.1-i486-1.tgz \
	xfindproxy-1.0.1-i486-1.tgz \
	xfontsel-1.0.2-i486-1.tgz \
	xfs-1.0.6-i486-1.tgz \
	xfsinfo-1.0.1-i486-1.tgz \
	xfwp-1.0.1-i486-1.tgz \
	xgamma-1.0.2-i486-1.tgz \
	xgc-1.0.1-i486-1.tgz \
	xhost-1.0.2-i486-1.tgz \
	xinit-1.0.8-i486-1.tgz \
	xinput-1.3.0-i486-1.tgz \
	xkbcomp-1.0.4-i486-1.tgz \
	xkbutils-1.0.1-i486-1.tgz \
	xkill-1.0.1-i486-1.tgz \
	xload-1.0.2-i486-1.tgz \
	xlogo-1.0.1-i486-1.tgz \
	xlsatoms-1.0.1-i486-1.tgz \
	xlsclients-1.0.1-i486-1.tgz \
	xlsfonts-1.0.2-i486-1.tgz \
	xmag-1.0.2-i486-1.tgz \
	xman-1.0.3-i486-1.tgz \
	xmessage-1.0.2-i486-1.tgz \
	xmh-1.0.1-i486-1.tgz \
	xmodmap-1.0.3-i486-1.tgz \
	xmore-1.0.1-i486-1.tgz \
	xphelloworld-1.0.1-i486-1.tgz \
	xplsprinters-1.0.1-i486-1.tgz \
	xpr-1.0.2-i486-1.tgz \
	xprehashprinterlist-1.0.1-i486-1.tgz \
	xprop-1.0.4-i486-1.tgz \
	xrandr-1.2.3-i486-1.tgz \
	xrdb-1.0.5-i486-1.tgz \
	xrefresh-1.0.2-i486-1.tgz \
	xrx-1.0.1-i486-1.tgz \
	xset-1.0.4-i486-1.tgz \
	xsetmode-1.0.0-i486-1.tgz \
	xsetpointer-1.0.1-i486-1.tgz \
	xsetroot-1.0.2-i486-1.tgz \
	xsm-1.0.1-i486-1.tgz \
	xstdcmap-1.0.1-i486-1.tgz \
	xvidtune-1.0.1-i486-1.tgz \
	xvinfo-1.0.2-i486-1.tgz \
	xwd-1.0.1-i486-1.tgz \
	xwininfo-1.0.3-i486-1.tgz \
	xwud-1.0.1-i486-1.tgz"
Patches=" "
Scripts=" \
	build-${Software_Name}.sh"
Miscellaneous=" \
	twm.desktop.gz \
	twm.png \
	zenwalk-twm-goodies.tar.bz2"



# Clean & Prep:
#_______________________________________________________________________



# Remove cruft and create Installation_Root:
	rm -rf ${Package}* ${Package}-src* 1>/dev/null 2>&1
	mkdir ${Installation_Root}
# Check For Necessary Files:
	for File in ${Sources} ${SlackPkgs} ${Patches} ${Scripts} ${Miscellaneous} ; do
		echo -n "${File} :"
		if [ -e ${File} ]; then
			echo " OK"
		else
			echo " MISSING !"
			exit 1
		fi
	done
# Add A Package Description File:
mkdir -p ${Installation_Root}/install
cat <<EOF0 > ${Installation_Root}/install/slack-desc 
         |-----handy-ruler------------------------------------------------------|
xorg-apps: xorg-apps (X.Org X11 applications)
xorg-apps:
xorg-apps: A collection of common X Window System applications.
xorg-apps:
xorg-apps:
xorg-apps:
xorg-apps:
xorg-apps:
xorg-apps:
xorg-apps:
xorg-apps:
EOF0
# Install Build Scripts Patches and Miscellaneous Items:
	mkdir -p ${Installation_Root}/usr/src/${Software_Name}-${Software_Version}
	cp ${Patches} ${Scripts} ${Miscellaneous} \
	${Installation_Root}/usr/src/${Software_Name}-${Software_Version}/



# Build:
#_______________________________________________________________________



# Everything here precompiled by Slackware.



# Special routines:
#_______________________________________________________________________



# Install the Slackware-built packages:
	mkdir -p ${Installation_Root}/install
		for Each in ${SlackPkgs} ; do
		mkdir /tmp/${Each}
		cd /tmp/${Each}
		explodepkg ${Build_Root}/${Each} .
		cat install/doinst.sh >> ${Installation_Root}/install/doinst.sh
		rm -rf install
		cp -aR * ${Installation_Root}/
		cd ${Build_Root}/
		rm -rf /tmp/${Each}
	done
# Added customized twm files:
	mkdir -p ${Installation_Root}/etc/X11/app-defaults/
	mkdir -p ${Installation_Root}/usr/share/X11/twm
	mkdir -p ${Installation_Root}/etc/X11/dm
	zcat ${Build_Root}/twm.desktop.gz > ${Installation_Root}/etc/X11/dm/twm.desktop
	mkdir -p ${Installation_Root}/etc/X11/xinit
	zcat ${Build_Root}/xinitrc.twm.gz > ${Installation_Root}/etc/X11/xinit/xinitrc.twm
	mkdir -p ${Installation_Root}/usr/share/icons/hicolor/48x48/apps
	cp ${Build_Root}/twm.png ${Installation_Root}/usr/share/icons/hicolor/48x48/apps/
	(
		cd ${Build_Root}/
		tar -xvjf zenwalk-twm-goodies.tar.bz2
		cd zenwalk-twm-goodies
		cp -aR * ${Installation_Root}
		mkdir -p ${Installation_Root}/root
		cp etc/skel/.twmrc ${Installation_Root}/root/
	)
	rm -rf ${Build_Root}/zenwalk-twm-goodies/*
	rmdir ${Build_Root}/zenwalk-twm-goodies
# If this is a new installation we assume they will use XFCE:
	zcat ${Build_Root}/doinst-xinit.sh.gz > ${Installation_Root}/install/doinst.sh



# Packaging:
#_______________________________________________________________________



# Strip Binaries:
	(
		cd ${Installation_Root}
		find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
		find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
	)
# Create dep file:
	(
		cd ${Installation_Root}
		requiredbuilder -z ${Installation_Root} >> ${Build_Root}/${Package}.dep
	)
# Compress The Package:
    (
      cd ${Installation_Root}
      makepkg -l y -c n ${Build_Root}/${Package}.tgz
    )
# Calculate The MD5 Sum:
    cd ${Build_Root}
      md5sum ${Package}.tgz > ${Package}.md5
# Create a source package and checksum:
	mkdir ${Package}-src
	cp  ${Sources} ${SlackPkgs} ${Patches} ${Scripts} ${Miscellaneous} \
		${Package}-src
	tar jcf ${Package}-src.tar.bz2 ${Package}-src
	md5sum ${Package}-src.tar.bz2 > ${Package}-src.md5
# Post Build Cleanup
	rm -rf ${Installation_Root} ${Package}-src



# Changelog:
#_______________________________________________________________________



# ~ Wed Feb 25th 2009	Michael Verret "axxium" <michael.verret@gmail.com>
# ~ Software: xorg-apps-7.3
# ~ Release: 60
# ~ Build: 2
# ~ Diff: Removed the icon and desktop file for bitmap:

# ~ Mon Feb 9th 2009	Michael Verret "axxium" <michael.verret@gmail.com>
# ~ Software: xorg-apps-7.3
# ~ Release: 60
# ~ Build: 1
# ~ Diff: Initial build containing:
# ~		appres-1.0.1
# ~		bdftopcf-1.0.1
# ~		beforelight-1.0.2
# ~		bitmap-1.0.3
# ~		editres-1.0.3
# ~		fonttosfnt-1.0.3
# ~		fslsfonts-1.0.1
# ~		fstobdf-1.0.2
# ~		iceauth-1.0.2
# ~		ico-1.0.2
# ~		lbxproxy-1.0.1
# ~		listres-1.0.1
# ~		luit-1.0.3
# ~		mkcomposecache-1.2
# ~		mkfontdir-1.0.4
# ~		mkfontscale-1.0.4
# ~		oclock-1.0.1
# ~		proxymngr-1.0.1
# ~		rendercheck-1.3
# ~		rgb-1.0.1
# ~		rstart-1.0.2
# ~		sessreg-1.0.3
# ~		showfont-1.0.1
# ~		smproxy-1.0.2
# ~		twm-1.0.4
# ~		viewres-1.0.1
# ~		x11perf-1.5
# ~		xauth-1.0.3
# ~		xbacklight-1.1
# ~		xbiff-1.0.1
# ~		xcalc-1.0.2
# ~		xclipboard-1.0.1
# ~		xclock-1.0.3
# ~		xcmsdb-1.0.1
# ~		xcompmgr-1.1.4
# ~		xconsole-1.0.3
# ~		xcursorgen-1.0.2
# ~		xdbedizzy-1.0.2
# ~		xditview-1.0.1
# ~		xdm-1.1.7
# ~		xdpyinfo-1.0.2
# ~		xdriinfo-1.0.2
# ~		xedit-1.0.2
# ~		xev-1.0.3
# ~		xeyes-1.0.1
# ~		xf86dga-1.0.2
# ~		xfd-1.0.1
# ~		xfindproxy-1.0.1
# ~		xfontsel-1.0.2
# ~		xfs-1.0.6
# ~		xfsinfo-1.0.1
# ~		xfwp-1.0.1
# ~		xgamma-1.0.2
# ~		xgc-1.0.1
# ~		xhost-1.0.2
# ~		xinit-1.0.8
# ~		xinput-1.3.0
# ~		xkbcomp-1.0.4
# ~		xkbutils-1.0.1
# ~		xkill-1.0.1
# ~		xload-1.0.2
# ~		xlogo-1.0.1
# ~		xlsatoms-1.0.1
# ~		xlsclients-1.0.1
# ~		xlsfonts-1.0.2
# ~		xmag-1.0.2
# ~		xman-1.0.3
# ~		xmessage-1.0.2
# ~		xmh-1.0.1
# ~		xmodmap-1.0.3
# ~		xmore-1.0.1
# ~		xphelloworld-1.0.1
# ~		xplsprinters-1.0.1
# ~		xpr-1.0.2
# ~		xprehashprinterlist-1.0.1
# ~		xprop-1.0.4
# ~		xrandr-1.2.3
# ~		xrdb-1.0.5
# ~		xrefresh-1.0.2
# ~		xrx-1.0.1
# ~		xset-1.0.4
# ~		xsetmode-1.0.0
# ~		xsetpointer-1.0.1
# ~		xsetroot-1.0.2
# ~		xsm-1.0.1
# ~		xstdcmap-1.0.1
# ~		xvidtune-1.0.1
# ~		xvinfo-1.0.2
# ~		xwd-1.0.1
# ~		xwininfo-1.0.3
# ~		xwud-1.0.1
